-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M= {}
local airspeedKPH= 0
local wheelspeedKPH= 0
local min= math.min
local max= math.max
local abs= math.abs
local atan= math.atan
local sqrt= math.sqrt
local clamp= clamp

electrics.values.thrusterDownforce= 1   -- type this in jbeam thruster section: "control":"thrusterDownforce"
electrics.values.thrusterThrottle= 0
electrics.values.thrusterBrake= 0
electrics.values.thrusterTurn= 0
electrics.values.thrusterDynamicDownforce= 0

electrics.values.thrusterFlyThrottle= nil
electrics.values.thrusterFlyPitch= 0
electrics.values.thrusterFlyRoll= 0
electrics.values.thrusterFlyYaw= 0

--local thrusterDownforceSignal= 1
--local thrusterDynamicDownforceSignal= 1
electrics.values.thrusterDownforceSignal= 1
electrics.values.thrusterDynamicDownforceSignal= 1
local thrusterDynamicDownforceDefaultState= 1
local thrusterDownforceDefaultState= 1

--[[
local rollAV, pitchAV, yawAV = obj:getRollPitchYawAngularVelocity() --fly
local roll, pitch, yaw = obj:getRollPitchYaw()
local flyPIDPitchKP,flyPIDPitchKI,flyPIDPitchKD= 0.5, 0.2, 0.008
local flyPIDRollKP,flyPIDRollKI,flyPIDRollKD= 0.5, 0.2, 0.008
local flyPIDYawKP,flyPIDYawKI,flyPIDYawKD= 0.5, 0.2, 0.008
local flyPIDPitch= newPIDParallel(flyPIDPitchKP,flyPIDPitchKI,flyPIDPitchKD, -2, 2)--min output/ max output
local flyPIDRoll= newPIDParallel(flyPIDRollKP,flyPIDRollKI,flyPIDRollKD, -2, 2)
local flyPIDYaw= newPIDParallel(flyPIDYawKP,flyPIDYawKI,flyPIDYawKD, -2, 2)
local flyPIDPitchAngle= newPIDParallel(2, 0.05, 0, -2, 2)
local flyPIDRollAngle= newPIDParallel(2, 0.05, 0, -2, 2)
--local flyPIDYawAngle= newPIDParallel(2, 0.05, 0, -2, 2)
local bodySlipAngle= 0
local flyControlMode= 2
--local useThrusterFlyThrottle

electrics.values.pitchTarget= 0
electrics.values.rollTarget= 0
electrics.values.yawTarget= 0

--]]

--[[
local function toggleThrusterDownforce()
    if thrusterDownforceSignal~= 0 then
        thrusterDownforceSignal= 0
    else
        thrusterDownforceSignal= 1
    end

    if thrusterDownforceSignal== 1 then
        electrics.values.thrusterDownforce= 1
    else
        electrics.values.thrusterDownforce= 0
    end
    
end

local function toggleThrusterDynamicDownforce()
    if thrusterDynamicDownforceSignal~= 0 then
        thrusterDynamicDownforceSignal= 0
    else
        thrusterDynamicDownforceSignal= 1
    end
end
--]]
local function init(jbeamData)
    thrusterDynamicDownforceDefaultState= jbeamData.thrusterDynamicDownforceDefaultState or 1
    thrusterDownforceDefaultState= jbeamData.thrusterDownforceDefaultState or 1
    if thrusterDynamicDownforceDefaultState== 0 then
        electrics.values.thrusterDynamicDownforceSignal= 0
    else
        electrics.values.thrusterDynamicDownforceSignal= 1
    end

    if thrusterDownforceDefaultState== 0 then
        electrics.values.thrusterDownforceSignal= 0
    else
        electrics.values.thrusterDownforceSignal= 1
    end
--[[
    --useThrusterFlyThrottle = jbeamData.useThrusterFlyThrottle or false
    if jbeamData.flyPIDPitchKP then --pitch pid
        flyPIDPitchKP= jbeamData.flyPIDPitchKP
    end
    if jbeamData.flyPIDPitchKI then
        flyPIDPitchKI= jbeamData.flyPIDPitchKI
    end
    if jbeamData.flyPIDPitchKD then
        flyPIDPitchKD= jbeamData.flyPIDPitchKD
    end
    if jbeamData.flyPIDRollKP then --roll pid
        flyPIDRollKP= jbeamData.flyPIDRollKP
    end
    if jbeamData.flyPIDRollKI then
        flyPIDRollKI= jbeamData.flyPIDRollKI
    end
    if jbeamData.flyPIDRollKD then
        flyPIDRollKD= jbeamData.flyPIDRollKD
    end
    if jbeamData.flyPIDYawKP then --yaw pid
        flyPIDYawKP= jbeamData.flyPIDYawKP
    end
    if jbeamData.flyPIDYawKI then
        flyPIDYawKI= jbeamData.flyPIDYawKI
    end
    if jbeamData.flyPIDYawKD then
        flyPIDYawKD= jbeamData.flyPIDYawKD
    end
    if jbeamData.flyControlMode then
        flyControlMode= jbeamData.flyControlMode
    end
--]]
end
local function reset()
    --electrics.values.thrusterThrottle= 0
    --electrics.values.thrusterBrake= 0
    electrics.values.thrusterTurn= 0
--[[
    --electrics.values.thrusterFlyThrottle= nil
    electrics.values.thrusterFlyPitch= 0
    electrics.values.thrusterFlyRoll= 0
    electrics.values.thrusterFlyYaw= 0
    electrics.values.pitchTarget= 0
    electrics.values.rollTarget= 0
    electrics.values.yawTarget= 0
    flyPIDPitch:reset()
    flyPIDRoll:reset()
    flyPIDYaw:reset()
    flyPIDRollAngle:reset()
    flyPIDPitchAngle:reset()
    --flyPIDYawAngle:reset()
--]]
    if thrusterDynamicDownforceDefaultState== 0 then
        electrics.values.thrusterDynamicDownforceSignal= 0
    else
        electrics.values.thrusterDynamicDownforceSignal= 1
    end

    if thrusterDownforceDefaultState== 0 then
        electrics.values.thrusterDownforceSignal= 0
    else
        electrics.values.thrusterDownforceSignal= 1
    end

end

local function updateGFX(dt)
    airspeedKPH= electrics.values.airspeed* 3.6 or 0
    wheelspeedKPH= electrics.values.wheelspeed* 3.6 or 0
    

    electrics.values.thrusterThrottle= input.throttle or 0
    electrics.values.thrusterBrake= input.brake or 0 

    if airspeedKPH<= 10 or wheelspeedKPH<=20 then
        electrics.values.thrusterTurn= input.steering* 0.5 or 0
    else
        electrics.values.thrusterTurn= input.steering or 0
    end

    if electrics.values.thrusterDynamicDownforceSignal== 0 then
        electrics.values.thrusterDynamicDownforce= 0
    else
        electrics.values.thrusterDynamicDownforce= max(0, min(1, (input.throttle+ input.brake)*1.7+ abs(input.steering* 3.5)+ 0) ) or 0
    end

    if electrics.values.thrusterDownforceSignal== 0 then
        electrics.values.thrusterDownforce= 0
    else
        electrics.values.thrusterDownforce= 1
    end
--[[
    --flying vehicle
    rollAV, pitchAV, yawAV = obj:getRollPitchYawAngularVelocity()
    roll, pitch, yaw = obj:getRollPitchYaw()
    local objGetVelocity= obj:getVelocity()
    local velocityX= objGetVelocity:dot(obj:getDirectionVector())
    local velocityY= objGetVelocity:dot(obj:getDirectionVectorRight())
    local velocityZ= objGetVelocity:dot(obj:getDirectionVectorUp())
    local velocityXY= sqrt(velocityX^2+velocityY^2) --水平方向速度绝对值，m/s
    --bodySlipAngle= obj:getVelocity():dot(obj:getDirectionVector())--controller.getController("CMU").virtualSensors.virtual.bodySlipAngle or "nil"
    if velocityXY*3.6>=20 then
        if velocityX>0 then
            if abs(pitch)<=0.8 then
                bodySlipAngle= clamp(velocityY*5/ velocityX , -1.5 ,  1.5 )
            else
                bodySlipAngle= 0
            end
        else 
            if velocityY>0 then
                bodySlipAngle= 1.5
            else
                bodySlipAngle= -1.5
            end
        end
        --bodySlipAngle= atan(velocityY, sqrt(velocityX^2+velocityZ^2))
    else
        bodySlipAngle= 0
    end
    
    if flyControlMode==2 then
        electrics.values.thrusterFlyYaw= flyPIDYaw:get(yawAV, 0.8*electrics.values.yawTarget+ bodySlipAngle*0.2, dt)
        electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, flyPIDPitchAngle:get(pitch, 0.85*electrics.values.pitchTarget+ 0.5*clamp((abs(roll*(electrics.values.thrusterFlyThrottle or electrics.values.thrusterThrottle))-velocityXY/277.777777777777 ),0,1),dt), dt)
        electrics.values.thrusterFlyRoll= flyPIDRoll:get(rollAV, flyPIDRollAngle:get(-roll, 0.8*electrics.values.rollTarget,dt), dt)
    else
        electrics.values.thrusterFlyYaw= flyPIDYaw:get(yawAV, 2*electrics.values.yawTarget+ bodySlipAngle*0.2, dt)
        if velocityXY<250 then
            electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, 2*electrics.values.pitchTarget+ 0.5*clamp(abs(roll* (electrics.values.thrusterFlyThrottle or electrics.values.thrusterThrottle))-velocityXY/277.777777777777,0,1), dt) --1000kph
        else
            electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, 2*electrics.values.pitchTarget+ 0.05*abs(roll* (electrics.values.thrusterFlyThrottle or electrics.values.thrusterThrottle)), dt)
        end
        
        electrics.values.thrusterFlyRoll= flyPIDRoll:get(rollAV, 2*electrics.values.rollTarget,dt)
    end

--]]


    --guihooks.message({txt = 0.5*clamp((abs(roll*(electrics.values.thrusterFlyThrottle or electrics.values.thrusterThrottle))-velocityXY/277.777777777777 ),0,1), context = {ttl = 5, color = "info"}})
    --log('W', logTag,  tostring(electrics.values.thrusterFlyThrottle))
end

local function updateSimpleControlButtons()
    extensions.ui_simplePowertrainControl.setButton("thrusterDownforce" , "Downforce", "powertrain_jato", "0072bc", 1, "electrics.values.thrusterDownforceSignal = 1 - (electrics.values.thrusterDownforceSignal or 1)")
    extensions.ui_simplePowertrainControl.setButton("thrusterDynamicDownforce", "DynamicDownforce", "powertrain_jato", "9072bc", 0.5, "electrics.values.thrusterDynamicDownforceSignal = 1 - (electrics.values.thrusterDynamicDownforceSignal or 1)")
end


--public interface
M.updateGFX= updateGFX
M.reset= reset
M.init= init
M.updateSimpleControlButtons = updateSimpleControlButtons--更新按键状态
--M.toggleThrusterDownforce= toggleThrusterDownforce
--M.toggleThrusterDynamicDownforce= toggleThrusterDynamicDownforce



return M --对外提供M集合以供调用控制函数